#
# spec file for package ghc-generically
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name generically
%global pkgver %{pkg_name}-%{version}
Name:           ghc-%{pkg_name}
Version:        0.1.1
Release:        5.6
Summary:        Generically newtype to use with DerivingVia
License:        BSD-3-Clause
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/4.cabal#/%{pkg_name}.cabal
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-rpm-macros
ExcludeArch:    %{ix86}

%description
This is a compatibility package as 'Generically' and 'Generically1' newtypes
are available since 'base-4.17' in 'GHC.Generics'.

%package devel
Summary:        Haskell %{pkg_name} library development files
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%package -n ghc-%{pkg_name}-doc
Summary:        Haskell %{pkg_name} library documentation
Requires:       ghc-filesystem
BuildArch:      noarch

%description -n ghc-%{pkg_name}-doc
This package provides the Haskell %{pkg_name} library documentation.

%package -n ghc-%{pkg_name}-prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       ghc-%{pkg_name}-devel = %{version}-%{release}
Supplements:    (ghc-%{pkg_name}-devel and ghc-prof)

%description -n ghc-%{pkg_name}-prof
This package provides the Haskell %{pkg_name} profiling library.

%prep
%autosetup -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc CHANGELOG.md

%files -n ghc-%{pkg_name}-doc -f ghc-%{pkg_name}-doc.files
%license LICENSE

%files -n ghc-%{pkg_name}-prof -f ghc-%{pkg_name}-prof.files

%changelog
* Thu Oct 31 2024 Peter Simons <psimons@suse.com>
- Update generically to version 0.1.1 revision 4.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu May 16 2024 Peter Simons <psimons@suse.com>
- Update generically to version 0.1.1 revision 3.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu Nov 16 2023 Peter Simons <psimons@suse.com>
- Drop obsolete dependency on ghc-base-orphans.
* Wed Oct  4 2023 Peter Simons <psimons@suse.com>
- Update generically to version 0.1.1 revision 2.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu Mar 30 2023 Peter Simons <psimons@suse.com>
- Updated spec file to conform with ghc-rpm-macros-2.5.2.
* Wed Mar 15 2023 Peter Simons <psimons@suse.com>
- Update generically to version 0.1.1 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Fri Mar 10 2023 Peter Simons <psimons@suse.com>
- Update generically to version 0.1.1.
  [#] 0.1.1 -- 2023-03-10
  * Backport `Eq` and `Ord` instances for `Generically1`, which were introduced
    in `base-4.18.0.0`. To ensure that these instances are in scope when building
    with `base-4.17.0.0` (in which `Generically1` is defined in `base`, not this
    library), we also add a dependency on `base-orphans`.
* Wed Jun 15 2022 Peter Simons <psimons@suse.com>
- Add generically at version 0.1.
